﻿//************************************************************
//CORETECH - SUMMARY PAGE
//Populates user input (questions and answers) on last page of a request offering
//History:
//
//Version    Date            Description
//1.0        27-09-2016      Initial version
//1.1    	 11-10-2016	     Dependency issue on instance control.
//1.2    	 12-10-2016	     Fixed instance control not working on search filter    
//*************************************************************


$(document).ready(function (formObj) {

    var flagWord = "Summary"

    function isSummaryPresent() {
        if(!$("#requestOfferingCont h3:contains(" + flagWord + ")"))
        {
            return;
        }
    } setTimeout(isSummaryPresent, 400);
    

    

    function showSummaryPage() {

        //Click event on Next button
        $("#drawer-taskbar > button:nth-child(2)").click(function (e) {

            var summaryPanel = $("#requestOfferingCont h3:contains(" + flagWord + ")").next();
            var answerCollection = [];

            //If this page is present with this word - Make a summary page
            if (summaryPanel.length) {

                //Load css style for page
                //summaryPanel.append($('<link rel="stylesheet" type="text/css" />').attr('href', "http://" + window.location.hostname + "/CustomSpace/CoretechSummaryPage.css"));

                $("[class*='question-container']").each(function () {
                    var obj = new Object();
                    obj.QuestionBaseId = $(this).find(".question-baseid").val();
                    obj.QuestionAnswerId = $(this).find(".question-answer-id").val();
                    obj.AnswerType = $(this).find(".question-answer-type").val();

                    //BOOL
                    if (obj.AnswerType == "Boolean") {
                        obj.Question = $(this).find(".checkbox-label")[0].outerText
                        obj.Answer = $(this).find("#" + obj.QuestionAnswerId).is(':checked');
                        answerCollection.push(obj);

                    } else {
                        //TEXTAREA
                        var objElement = $(this).find("#textArea" + obj.QuestionAnswerId);
                        if (!_.isUndefined(objElement[0]) && objElement[0].tagName == "TEXTAREA") {
                            obj.Answer = objElement.val();
                            obj.Question = $(this).find(".control-label")[0].outerText


                            //QUERY RESULT
                        } else {
                            obj.Question = $(this).find(".control-label")[0].outerText

                            if (obj.AnswerType === "InstancePicker") {

                                //Get column headers from query result table
                                var columns = $(this).find("input[id=Columns" + obj.QuestionAnswerId + "]").val();
                                columns = columns.split("(((;)))");
                                var headers = "";
                                columns.forEach(function (entry) {
                                    headers += "<th>" + entry.split("(((:)))")[0] + "</th>";
                                });
                                headers = "<tr>" + headers + "</tr>";


                                var selectedItems = "";
                                obj.Answer = "";
                                $(selectedQueryItems[obj.QuestionBaseId]).each(function (index, value) {

                                    selectedItems += "<tr>" + value + "</tr>"

                                });

                                //Create table of query result picks
                                if (selectedItems.length > 0) {
                                    obj.Answer = "<table class='summaryQueryResultTable'>" + headers + selectedItems + "</table>"
                                }


                            } else {
                                //ENUMERATIONS
                                var control = $(this).find("div[data-control='dropDownTree']").toArray()
                                if (control.length) {

                                    obj.Answer = $(this).find("input[id=Name" + obj.QuestionAnswerId + "]").val();

                                } else { //SIMPLE LIST
                                    obj.Answer = $(this).find("#" + obj.QuestionAnswerId).val();
                                }


                            }


                        }
                        answerCollection.push(obj);

                    }




                });//foreach question in container

                summaryPanel.empty();
                answerCollection.forEach(function (obj, index) {


                    //console.log(obj.Question);
                    //console.log(obj.Answer);
                    //console.log(obj.Answer.length)
                    if (obj.Answer.length || obj.AnswerType == "Boolean") {
                        summaryPanel.append("<h4>" + obj.Question + "</h4>")
                        summaryPanel.append("<p>" + obj.Answer + "</p>")
                    }


                });

                //CSS Style table and rows of query result
                var summaryTable = $(".summaryQueryResultTable");
                if ($(".summaryQueryResultTable").length) {
                    summaryTable.css("border", "1px solid #cfcfcf");
                    summaryTable.find("th").css("border", "2px solid #cfcfcf");
                    summaryTable.find("td").css("border", "1px solid #cfcfcf");

                }

            } //if summary
        }); //next click even



    } //ShowSummaryPage()
    

    var selectedQueryItems = {};
    function handleQueryLists() {
       
        $("[class*='question-container']").each(function (index, inputEntry) {
            var AnswerType = $(inputEntry).find(".question-answer-type").val();

            if (AnswerType === "InstancePicker") {
                
                    //Query buttons: Back, forward, page numbers etc.
                    var queryButtons = $(inputEntry).find("a.k-link.k-pager-nav, .k-pager-numbers")
                    var isMultiSelect = $(inputEntry).find("[data-control-ismultiselect=True]").length ? true : false
                    var pagesHandled = []; //array to keep track if query result page has been handled aka. added event handlers on each row
                    var baseId = $(inputEntry).find(".question-baseid").val(); //unique Id for the specific query result
                    var selectedArr = [];
                    selectedQueryItems[baseId] = selectedArr; //designate an array of selected items (clicked items) to each query result on RO
                    var rowDictClickedTimes = {}; //object to store number of clicks on an query result item

                    //helper function check if number is even
                    function isEven(n) {
                        return n % 2 == 0;
                    }
	
                    //Create click event for each table row first time page loads:
					
                    
                    function createRowClickEvent() {
                        console.log("Creating click events on rows...");
                        //Get current query page
                        var pageNumber = $(inputEntry).find(".k-current-page");

                        //Get the table rows (should be the ones from current page since time has passed)
                        queryRows = $(inputEntry).find("table tr");

                        //Check if event for each row has already been made
                        if ($.inArray(pageNumber[0].innerText, pagesHandled) != -1) {
                            //Page is already handled
                        } else {
                            //Page is not handled (first time page is loaded) - add to array
                            pagesHandled.push(pageNumber[0].innerText);
                            //set all table rows to have been clicked zero times
                            queryRows.each(function () {
                                rowDictClickedTimes[$(this).attr("data-uid")] = 0;
                                
                            });
                            
                        }

                        //make a click event on each table row
                        queryRows.on("click", function () {
                            //get parent context for this row clicked
                            var queryParentItem = $(this).parent().context;
                           
                            //Check if query result is a multi selection
                            if (isMultiSelect) {
                                //increment by 1 the number of times this row has been clicked, store it in dictionary object
                                rowDictClickedTimes[$(this).attr("data-uid")] = rowDictClickedTimes[$(this).attr("data-uid")] + 1;

                                if (isEven(rowDictClickedTimes[$(this).attr("data-uid")])) {
                                    //Even clicked times = row is unselected. Remove from array:
                                    selectedArr.splice(selectedArr.indexOf($(this)[0].innerHTML), 1);
                                    selectedQueryItems[baseId] = selectedArr

                                } else {
                                    //Odd clicked times = row is selected. Add it to array
                                    selectedArr.push($(this)[0].innerHTML)
                                    selectedQueryItems[baseId] = selectedArr
                                }
                            } else {
                                selectedArr = []; //Reset array as we only need one value anyway since this is not multi select
                                selectedArr.push($(this)[0].innerHTML)
                                selectedQueryItems[baseId] = selectedArr
                            }
                           
                        });//on query row click

                    } //createRowClickEvent
					
					//Run row click event on load
					createRowClickEvent();
                     var searchInput = $(inputEntry).find(".searchInput")

                     //Run row click event when tabel changes
                     $(searchInput).on("change", function() {
                        
                        createRowClickEvent();
                        //Create click event for each table row when query page changes
                        //setTimeout(createRowClickEvent, 100); //Timeout to ensure next page is loaded (suggestions are welcome)


                    });
                    
                    //Run click when pages changes.
                    $(queryButtons).on("click", function() {
                   
                        //Create click event for each table row when query page changes
                        setTimeout(createRowClickEvent, 100); //Timeout to ensure next page is loaded (suggestions are welcome)
                      


                    }); //queryButtons click event


                //} //if button not disabled (check on multi-page
            } //if instance picker
        }); //Foreach question
		
		//Run Summary Page finally
		console.log("getting summary...");
		setTimeout(showSummaryPage, 200);

		
    }
    setTimeout(handleQueryLists, 1000);

});



